VirtualBox

source: vbox/trunk/configure@ 8155

Last change on this file since 8155 was 8073, checked in by vboxsync, 16 years ago

configure: Qt4 is default enabled on Darwin again, --disable-qt disables both Qt3 and Qt4

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 45.7 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2007 innotek GmbH
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License as published by the Free Software Foundation,
12# in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
13# distribution. VirtualBox OSE is distributed in the hope that it will
14# be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, echo, grep, sed to work)
23PATH="/usr/xpg4/bin:/usr/ucb:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26#
27# Defaults
28#
29OSE=1
30ODIR="`pwd`/"
31SETUP_WINE=
32TARGET_MACHINE=""
33TARGET_CPU=""
34WITH_XPCOM=1
35WITH_LIBIDL=1
36WITH_QT=1
37WITH_QT4=1
38WITH_SDL=1
39WITH_SDL_TTF=1
40WITH_X11=1
41WITH_ALSA=1
42WITH_PULSE=1
43WITH_KMODS=1
44CC="gcc"
45CC32=""
46CC64=""
47CXX="g++"
48CXX32=""
49CXX64=""
50BCC="bcc"
51YASM="yasm"
52IASL="iasl"
53AS86="as86"
54XSLTPROC="xsltproc"
55GENISOIMAGE="genisoimage"
56MKISOFS="mkisofs"
57BUILD_LIBXML2=
58BUILD_LIBXSLT=
59LIBCRYPTO="-lcrypto"
60LIBPTHREAD="-lpthread"
61LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
62INCX11="/usr/local/include"
63LIBXCURSOR="-lXcursor"
64INCZ=""
65LIBZ="-lz"
66INCPNG=""
67LIBPNG="-lpng"
68QT3DIR="/usr/qt/3 /usr/lib/qt3 /usr/lib/qt-3.3 /usr/share/qt3 /usr/lib64/qt-3.3 /usr/X11R6 /usr/lib/qt"
69QT4DIR="/usr/lib/qt4 /usr/share/qt4 /usr"
70QT4UIC3DIR="/usr/bin"
71KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
72DEVDIR="`cd \`dirname $0\`; pwd`/tools"
73if [ -d "/lib/modules/`uname -r`/build" ]; then
74 LINUX="/lib/modules/`uname -r`/build"
75else
76 LINUX="/usr/src/linux"
77fi
78KCHMVIEWER="kchmviewer"
79LOG="configure.log"
80CNF="AutoConfig.kmk"
81ENV="env.sh"
82BUILD_TYPE="release"
83# the restricting tool is ar (mri mode).
84INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
85
86if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
87 echo "Error: VBox base path contains invalid characters!"
88 exit 1
89fi
90
91# darwin /bin/sh has a builtin echo that doesn't grok -n. gotta love it.
92if [ "`uname`" = "Darwin" ]; then
93 ECHO_N="/bin/echo -n"
94else
95 ECHO_N="echo -n"
96fi
97
98
99cleanup()
100{
101 rm -f .tmp_src.cc .tmp_src.c .tmp_out .test_execute.log
102}
103
104fail()
105{
106 if [ -z "$nofatal" -o "x$1" != "x" ]; then
107 cleanup
108 rm -f $ENV
109 exit 1
110 fi
111}
112
113log_success()
114{
115 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
116 echo "OK."
117 echo "$1" >> $LOG
118 echo >> $LOG
119 echo >> $LOG
120}
121
122log_failure()
123{
124 echo
125 echo " ** $1!"
126 echo "** $1!" >> $LOG
127 echo >> $LOG
128}
129
130cnf_append()
131{
132 printf "%-30s := %s\n" "$1" "$2" >> $CNF
133}
134
135strip_l()
136{
137 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|-[^l]\([^ ]\+\)||g; s|^ ||; s| *$||g'
138}
139
140strip_L()
141{
142 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|-[^L]\([^ ]\+\)||g; s|^ ||; s| *$||g'
143}
144
145strip_I()
146{
147 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|-[^I]\([^ ]\+\)||g; s|^ ||; s| *$||g'
148}
149
150prefix_I()
151{
152 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
153}
154
155# Wrapper for ancient /usr/bin/which on darwin that always returns 0
156which_wrapper()
157{
158 if [ -z "$have_ancient_which" ]; then
159 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
160 have_ancient_which="yes"
161 else
162 have_ancient_which="no"
163 fi
164 fi
165 if [ "$have_ancient_which" = "yes" ]; then
166 retval=`which $* 2>/dev/null`
167 echo "$retval"
168 test -n "$retval" -a -e "$retval"
169 unset retval
170 else
171 which $* 2> /dev/null
172 fi
173}
174
175check_avail()
176{
177 if [ -z "$1" ]; then
178 log_failure "$2 is empty"
179 fail $3
180 return 1
181 elif which_wrapper $1 > /dev/null; then
182 return 0
183 else
184 log_failure "$1 (variable $2) not found"
185 fail $3
186 return 1
187 fi
188}
189
190# Prepare a test
191test_header()
192{
193 echo "***** Checking $1 *****" >> $LOG
194 $ECHO_N "Checking for $1: "
195}
196
197# Compile a test
198test_compile()
199{
200 echo "compiling the following source file:" >> $LOG
201 cat .tmp_src.cc >> $LOG
202 echo "using the following command line:" >> $LOG
203 echo "$CXX -O -Wall -o .tmp_out .tmp_src.cc \"$1\"" >> $LOG
204 $CXX -O -Wall -o .tmp_out .tmp_src.cc $1 >> $LOG 2>&1
205 if [ $? -ne 0 ]; then
206 if [ -z "$4" ]; then
207 echo
208 echo " $2 not found at $1 or $3 headers not found"
209 echo " Check the file $LOG for detailed error information."
210 fail
211 else
212 echo "not found."
213 echo >> $LOG
214 echo >> $LOG
215 fi
216 return 1
217 fi
218 return 0
219}
220
221# Execute a compiled test binary
222test_execute()
223{
224 echo "executing the binary" >> $LOG
225 ./.tmp_out > .test_execute.log
226 rc=$?
227 cat .test_execute.log | tee -a $LOG
228 if [ $rc -ne 0 ]; then
229 fail $1
230 return 1
231 fi
232 echo >> $LOG
233 echo >> $LOG
234 return 0
235}
236
237#
238# Check for OS, MACHINE, CPU
239#
240check_environment()
241{
242 test_header environment
243 OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr [:upper:] [:lower:]`
244 case "$OS" in
245 linux)
246 ;;
247 darwin)
248 ;;
249 freebsd)
250 ;;
251 sunos)
252 OS='solaris'
253 ;;
254 *)
255 log_failure "Cannot determine OS"
256 exit 1
257 ;;
258 esac
259 BUILD_CPU=`uname -m`
260 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
261 case "$BUILD_CPU" in
262 i[3456789]86|x86|i86pc)
263 BUILD_MACHINE='x86'
264 LIB='lib'
265 ;;
266 x86_64|amd64)
267 BUILD_MACHINE='amd64'
268 BUILD_CPU='k8'
269 if [ "$OS" != "solaris" ]; then
270 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
271 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
272 LIB='lib64'
273 else
274 # Solaris doesn't seem to subscribe to fhs, libs are usually in
275 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
276 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
277 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
278 # have to make sure the */bin/amd64 dirs are searched before the */bin
279 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
280 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
281 echo "old PATH: $PATH" >> $LOG
282 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
283 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
284 export PATH
285 echo "new PATH: $PATH" >> $LOG
286 LIB='lib/64'
287 fi
288 ;;
289 *)
290 log_failure "Cannot determine system"
291 exit 1
292 ;;
293 esac
294 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
295 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
296 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
297 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
298
299 echo "export BUILD_PLATFORM=\"$OS\"" >> $ENV
300 echo "export BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
301 echo "export BUILD_TARGET=\"$OS\"" >> $ENV
302 echo "export BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
303 echo "export BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
304 echo "export BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
305}
306
307#
308# Check for gcc with version >= 3.2.
309# We depend on a working gcc, if we fail terminate in every case.
310#
311check_gcc()
312{
313 test_header gcc
314 if check_avail "$CC" CC really; then
315 cc_ver=`$CC -dumpversion`
316 if check_avail "$CXX" CXX really; then
317 cxx_ver=`$CXX -dumpversion`
318 cc_maj=`echo $cc_ver|cut -d. -f1`
319 cc_min=`echo $cc_ver|cut -d. -f2`
320 if [ "x$cc_ver" != "x$cxx_ver" ]; then
321 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
322 fail really
323 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 ]; then
324 if [ "$OS" = "darwin" ]; then
325 log_success "found version $cc_ver"
326 else
327 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with x>0"
328 fail really
329 fi
330 elif [ $cc_maj -gt 3 ]; then
331 log_success "found version $cc_ver"
332 elif [ $cc_maj -lt 3 -o $cc_min -lt 2 ]; then
333 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with x>0"
334 fail really
335 else
336 log_success "found version $cc_ver"
337 fi
338 if [ "$BUILD_MACHINE" = "amd64" ]; then
339 [ -z "$CC32" ] && CC32="$CC -m32"
340 [ -z "$CXX32" ] && CXX32="$CXX -m32"
341 else
342 [ -z "$CC32" ] && CC32="$CC"
343 [ -z "$CXX32" ] && CXX32="$CXX"
344 fi
345 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
346 [ -z "$CC64" ] && CC64="$CC -m64"
347 [ -z "$CXX64" ] && CXX64="$CXX -m64"
348 fi
349 if [ "$CC" != "gcc" ]; then
350 cnf_append "TOOL_GCC3_CC" "$CC"
351 cnf_append "TOOL_GCC3_AS" "$CC"
352 cnf_append "TOOL_GCC3_LD" "$CC"
353 cnf_append "TOOL_GXX3_CC" "$CC"
354 cnf_append "TOOL_GXX3_AS" "$CC"
355 fi
356 if [ "$CXX" != "g++" ]; then
357 cnf_append "TOOL_GCC3_CXX" "$CXX"
358 cnf_append "TOOL_GXX3_CXX" "$CXX"
359 cnf_append "TOOL_GXX3_LD" "$CXX"
360 fi
361 if [ "$CC32" != "gcc -m32" ]; then
362 cnf_append "TOOL_GCC32_CC" "$CC32"
363 cnf_append "TOOL_GCC32_AS" "$CC32"
364 cnf_append "TOOL_GCC32_LD" "$CC32"
365 cnf_append "TOOL_GXX32_CC" "$CC32"
366 cnf_append "TOOL_GXX32_AS" "$CC32"
367 fi
368 if [ "$CXX32" != "g++ -m32" ]; then
369 cnf_append "TOOL_GCC32_CXX" "$CXX32"
370 cnf_append "TOOL_GXX32_CXX" "$CXX32"
371 cnf_append "TOOL_GXX32_LD" "$CXX32"
372 fi
373 # this isn't not necessary, there is not such tool.
374 if [ -n "$CC64" ]; then
375 cnf_append "TOOL_GCC64_CC" "$CC64"
376 cnf_append "TOOL_GCC64_AS" "$CC64"
377 cnf_append "TOOL_GCC64_LD" "$CC64"
378 cnf_append "TOOL_GXX64_CC" "$CC64"
379 cnf_append "TOOL_GXX64_AS" "$CC64"
380 fi
381 if [ -n "$CXX64" ]; then
382 cnf_append "TOOL_GCC64_CXX" "$CXX64"
383 cnf_append "TOOL_GXX64_CXX" "$CXX64"
384 cnf_append "TOOL_GXX64_LD" "$CXX64"
385 fi
386 # Solaris sports a 32-bit gcc/g++.
387 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
388 [ "$CC" = "gcc" ] && CC="gcc -m64"
389 [ "$CXX" = "g++" ] && CXX="g++ -m64"
390 fi
391 fi
392 fi
393}
394
395#
396# Check for the bcc compiler, needed for compiling the BIOS
397#
398check_bcc()
399{
400 test_header bcc
401 if check_avail "$BCC" BCC; then
402 bcc_ver=`$BCC -v 2>&1|grep version|sed 's+^bcc: version \(.*\)+\1+'`
403 if [ $? -ne 0 ]; then
404 log_failure "not found"
405 fail
406 else
407 echo "compiling the following source file:" >> $LOG
408 cat > .tmp_src.c << EOF
409int foo(a)
410 int a;
411{
412 return 0;
413}
414EOF
415 cat .tmp_src.c >> $LOG
416 bcc_path=`which_wrapper $BCC`
417 bcc_dir="`dirname $bcc_path`/"
418 echo "using the following command line:" >> $LOG
419 echo "$BCC -B $bcc_dir -C-c -3 -S -o .tmp_out .tmp_src.c" >> $LOG
420 $BCC -B $bcc_dir -C-c -3 -S -o .tmp_out .tmp_src.c >> $LOG 2>&1
421 if [ $? -ne 0 ]; then
422 log_failure "not found"
423 fail
424 else
425 log_success "found version $bcc_ver"
426 cnf_append "VBOX_BCC" "$bcc_path -B $bcc_dir"
427 fi
428 unset bcc_path
429 unset bcc_dir
430 fi
431 fi
432}
433
434#
435# Check for the as86 assembler, needed for compiling the BIOS
436#
437check_as86()
438{
439 test_header as86
440 if check_avail "$AS86" AS86; then
441 as86_ver=`$AS86 -v 2>&1|grep version|sed 's+^as86 version: \(.*\)+\1+'`
442 if [ $? -ne 0 ]; then
443 log_failure "not found"
444 fail
445 else
446 log_success "found version $as86_ver"
447 cnf_append "VBOX_AS86" "`which_wrapper $AS86`"
448 fi
449 fi
450}
451
452#
453# Check for yasm, needed to compile assembler files
454#
455check_yasm()
456{
457 test_header yasm
458 if check_avail "$YASM" YASM; then
459 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
460 if [ $? -ne 0 ]; then
461 log_failure "not found"
462 fail
463 else
464 yasm_maj=`echo $yasm_ver|cut -d. -f1`
465 yasm_min=`echo $yasm_ver|cut -d. -f2`
466 yasm_rev=`echo $yasm_ver|cut -d. -f3`
467 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
468 if [ $yasm_ver_mul -lt 501 ]; then
469 log_failure "found version $yasm_ver, expected at least 0.5.1"
470 fail
471 else
472 log_success "found version $yasm_ver"
473 fi
474 fi
475 fi
476}
477
478#
479# Check for the iasl ACPI compiler, needed to compile vbox.dsl
480#
481check_iasl()
482{
483 test_header iasl
484 if check_avail "$IASL" IASL; then
485 iasl_ver=`$IASL|grep version|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
486 if [ $? -ne 0 ]; then
487 log_failure "not found"
488 fail
489 else
490 log_success "found version $iasl_ver"
491 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
492 fi
493 fi
494}
495
496#
497# Check for xsltproc, needed by Main
498#
499check_xsltproc()
500{
501 test_header xslt
502 if check_avail "$XSLTPROC" XSLTPROC; then
503 xsltproc_ver=`$XSLTPROC --version`
504 if [ $? -ne 0 ]; then
505 log_failure "not found"
506 fail
507 else
508 log_success "found"
509 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
510 fi
511 fi
512}
513
514#
515# Check for mkisofs, needed to build the CDROM image containing the additions
516#
517check_mkisofs()
518{
519 test_header mkisofs
520 if which_wrapper $GENISOIMAGE > /dev/null; then
521 mkisofs_ver=`$GENISOIMAGE --version`
522 if [ $? -ne 0 ]; then
523 log_failure "not found"
524 fail
525 else
526 log_success "found $mkisofs_ver"
527 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
528 fi
529 elif check_avail "$MKISOFS" MKISOFS; then
530 mkisofs_ver=`$MKISOFS --version`
531 if [ $? -ne 0 ]; then
532 log_failure "not found"
533 fail
534 else
535 log_success "found $mkisofs_ver"
536 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
537 fi
538 fi
539}
540
541#
542# Check for libxml2, needed by VBoxSettings
543# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
544#
545check_libxml2()
546{
547 if [ -z "$BUILD_LIBXML2" ]; then
548 test_header libxml2
549 if which_wrapper pkg-config > /dev/null; then
550 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
551 if [ $? -ne 0 ]; then
552 log_failure "not found"
553 fail
554 else
555 FLGXML2=`pkg-config libxml-2.0 --cflags`
556 INCXML2=`strip_I "$FLGXML2"`
557 LIBXML2=`pkg-config libxml-2.0 --libs`
558 cat > .tmp_src.cc << EOF
559#include <cstdio>
560#include <libxml/xmlversion.h>
561extern "C" int main(void)
562{
563 printf("found version %s", LIBXML_DOTTED_VERSION);
564#if LIBXML_VERSION >= 20626
565 printf(", OK.\n");
566 return 0;
567#else
568 printf(", expected version 2.6.26 or higher\n");
569 return 1;
570#endif
571}
572EOF
573 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
574 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
575 if test_execute; then
576 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
577 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
578 fi
579 fi
580 fi
581 elif which_wrapper xml2-config; then
582 libxml2_ver=`xml2-config --version`
583 if [ $? -ne 0 ]; then
584 log_failure "not found"
585 fail
586 else
587 log_success "found version $libxml2_ver"
588 FLGXML2=`xml2-config --cflags`
589 INCXML2=`strip_I "$FLGXML2"`
590 LIBXML2=`xml2-config --libs`
591 cat > .tmp_src.cc << EOF
592#include <cstdio>
593#include <libxml/xmlversion.h>
594extern "C" int main(void)
595{
596 printf("found version %s", LIBXML_DOTTED_VERSION);
597#if LIBXML_VERSION >= 20626
598 printf(", OK.\n");
599 return 0;
600#else
601 printf(", expected version 2.6.26 or higher\n");
602 return 1;
603#endif
604}
605EOF
606 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
607 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
608 if test_execute; then
609 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
610 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
611 fi
612 fi
613 fi
614 else
615 log_failure "neither pkg-config nor xml2-config found"
616 fail
617 fi
618 fi
619}
620
621#
622# Check for libxslt, needed by VBoxSettings. For now we depend on 1.1.17.
623# This library is available on Ubuntu Edgy which fulfils the minimal libxml2
624# requirement (2.6.26).
625#
626check_libxslt()
627{
628 if [ -z "$BUILD_LIBXSLT" ]; then
629 test_header libxslt
630 if which_wrapper pkg-config > /dev/null; then
631 libxslt_ver=`pkg-config libxslt --modversion 2>> $LOG`
632 if [ $? -ne 0 ]; then
633 log_failure "not found"
634 fail
635 else
636 FLGXSLT=`pkg-config libxslt --cflags`
637 INCXSLT=`strip_I "$FLGXSLT"`
638 LIBXSLT=`pkg-config libxslt --libs`
639 cat > .tmp_src.cc << EOF
640#include <cstdio>
641#include <libxslt/xsltconfig.h>
642extern "C" int main(void)
643{
644 printf("found version %s", LIBXSLT_DOTTED_VERSION);
645#if LIBXSLT_VERSION >= 10117
646 printf(", OK.\n");
647 return 0;
648#else
649 printf(", expected version 1.1.17 or higher\n");
650 return 1;
651#endif
652}
653EOF
654 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
655 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
656 if test_execute; then
657 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
658 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
659 fi
660 fi
661 fi
662 elif which_wrapper xslt-config; then
663 libxslt_ver=`xslt-config --version`
664 if [ $? -ne 0 ]; then
665 log_failure "not found"
666 fail
667 else
668 log_success "found version $libxslt_ver"
669 FLGXSLT=`xslt-config --cflags`
670 INCXSLT=`strip_I "$FLGXSLT"`
671 LIBXSLT=`xslt-config --libs`
672 cat > .tmp_src.cc << EOF
673#include <cstdio>
674#include <libxslt/xsltconfig.h>
675extern "C" int main(void)
676{
677 printf("found version %s", LIBXSLT_DOTTED_VERSION);
678#if LIBXSLT_VERSION >= 10117
679 printf(", OK.\n");
680 return 0;
681#else
682 printf(", expected version 1.1.17 or higher\n");
683 return 1;
684#endif
685}
686EOF
687 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
688 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
689 if test_execute; then
690 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
691 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
692 fi
693 fi
694 fi
695 else
696 log_failure "neither pkg-config nor xslt-config found"
697 fail
698 fi
699 fi
700}
701
702#
703# Check for libIDL, needed by xpcom
704#
705check_libidl()
706{
707 test_header libIDL
708
709 if which_wrapper libIDL-config-2 > /dev/null; then
710 libidl_ver=`libIDL-config-2 --version`
711 if [ $? -ne 0 ]; then
712 log_failure "not found"
713 fail
714 else
715 log_success "found version $libidl_ver"
716 cnf_append "VBOX_LIBIDL_CONFIG" \
717 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
718 fi
719 elif check_avail "libIDL-config" libIDL-config; then
720 libidl_ver=`libIDL-config --version`
721 if [ $? -ne 0 ]; then
722 log_failure "not found"
723 fail
724 else
725 log_success "found version $libidl_ver"
726 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
727 fi
728 fi
729}
730
731#
732# Check for openssl, needed for RDP
733#
734check_ssl()
735{
736 test_header ssl
737 cat > .tmp_src.cc << EOF
738#include <cstdio>
739#include <openssl/opensslv.h>
740extern "C" int main(void)
741{
742 printf("found version %s", OPENSSL_VERSION_TEXT);
743#if OPENSSL_VERSION_NUMBER >= 0x0090700
744 printf(", OK.\n");
745 return 0;
746#else
747 printf(", expected version 0.9.7 or higher\n");
748 return 1;
749#endif
750}
751EOF
752 if test_compile $LIBCRYPTO libcrypto openssl; then
753 if test_execute nofatal; then
754 cnf_append "SDK_VBOX_OPENSSL_INCS" ""
755 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
756 fi
757 fi
758}
759
760#
761# Check for pthread, needed by VBoxSVC, frontends, ...
762#
763check_pthread()
764{
765 test_header pthread
766 cat > .tmp_src.cc << EOF
767#include <cstdio>
768#include <pthread.h>
769extern "C" int main(void)
770{
771 pthread_mutex_t mutex;
772 if (pthread_mutex_init(&mutex, NULL)) {
773 printf("pthread_mutex_init() failed\n");
774 return 1;
775 }
776 if (pthread_mutex_lock(&mutex)) {
777 printf("pthread_mutex_lock() failed\n");
778 return 1;
779 }
780 if (pthread_mutex_unlock(&mutex)) {
781 printf("pthread_mutex_unlock() failed\n");
782 return 1;
783 }
784 printf("found, OK.\n");
785}
786EOF
787 if test_compile $LIBPTHREAD pthread pthread; then
788 if test_execute; then
789 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
790 fi
791 fi
792}
793
794#
795# Check for zlib, needed by VBoxSVC, Runtime, ...
796#
797check_z()
798{
799 test_header zlib
800 cat > .tmp_src.cc << EOF
801#include <cstdio>
802#include <zlib.h>
803extern "C" int main(void)
804{
805 printf("found version %s", ZLIB_VERSION);
806#if ZLIB_VERNUM >= 0x1210
807 printf(", OK.\n");
808 return 0;
809#else
810 printf(", expected version 1.2.1 or higher\n");
811 return 1;
812#endif
813}
814EOF
815 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
816 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
817 if test_execute; then
818 cnf_append "SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
819 cnf_append "SDK_VBOX_ZLIB_INCS" "$INCZ"
820 fi
821 fi
822}
823
824#
825# Check for libpng, needed by kchmviewer
826#
827check_png()
828{
829 test_header libpng
830 cat > .tmp_src.cc << EOF
831#include <cstdio>
832#include <png.h>
833extern "C" int main(void)
834{
835 printf("found version %s", PNG_LIBPNG_VER_STRING);
836#if PNG_LIBPNG_VER >= 10205
837 printf(", OK.\n");
838 return 0;
839#else
840 printf(", expected version 1.2.5 or higher\n");
841 return 1;
842#endif
843}
844EOF
845 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
846# if test_compile "$LIBPNG $I_INCPNG" libpng libpng nofatal; then
847 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
848# if test_execute nofatal; then
849 if test_execute; then
850 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
851 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
852 fi
853 fi
854}
855
856#
857# Check for pam, needed by VRDPAuth
858# Version 79 was introduced in 9/2005, do we support older versions?
859# Debian/sarge uses 76
860# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
861#
862check_pam()
863{
864 test_header pam
865 cat > .tmp_src.cc << EOF
866#include <cstdio>
867#include <security/pam_appl.h>
868extern "C" int main(void)
869{
870 printf("found version %d", __LIBPAM_VERSION);
871 if (__LIBPAM_VERSION >= 76)
872 {
873 printf(", OK.\n");
874 return 0;
875 }
876 else
877 {
878 printf(", expected version 76 or higher\n");
879 return 1;
880 }
881}
882EOF
883 if test_compile "-lpam" pam pam nofatal; then
884 if test_execute nofatal; then
885 return 0;
886 fi
887 fi
888 test_header linux_pam
889 cat > .tmp_src.cc << EOF
890#include <cstdio>
891#include <security/pam_appl.h>
892extern "C" int main(void)
893{
894 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
895 if (__LINUX_PAM__ >= 1)
896 {
897 printf(", OK.\n");
898 return 0;
899 }
900 else
901 {
902 printf(", expected version 1.0 or higher\n");
903 return 1;
904 }
905}
906EOF
907 if test_compile "-lpam" pam pam; then
908 test_execute
909 fi
910}
911
912
913#
914# Check for the SDL library, needed by VBoxSDL and VirtualBox
915# We depend at least on version 1.2.7
916#
917check_sdl()
918{
919 test_header SDL
920 if [ "$OS" = "darwin" ]; then
921 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
922 PATH_SDK_LIBSDL="/System/Library/Framework/SDL.framework"
923 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
924 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
925 fi
926 if [ -n "$PATH_SDK_LIBSDL" ]; then
927 foundsdl=1
928 INCSDL="$PATH_SDK_LIBSDL/Headers"
929 FLDSDL="-framework SDL"
930 else
931 log_failure "SDL framework not found"
932 fail
933 fi
934 else
935 if which_wrapper sdl-config > /dev/null; then
936 FLGSDL=`sdl-config --cflags`
937 INCSDL=`strip_I "$FLGSDL"`
938 LIBSDL=`sdl-config --libs`
939 LIBSDLMAIN="-lSDLmain"
940 FLDSDL=
941 foundsdl=1
942 fi
943 fi
944 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
945 if [ -n "$foundsdl" ]; then
946 cat > .tmp_src.cc << EOF
947#include <cstdio>
948#include <SDL.h>
949#include <SDL_main.h>
950#undef main
951extern "C" int main(int argc, char** argv)
952{
953 printf("found version %d.%d.%d",
954 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
955#if SDL_VERSION_ATLEAST(1,2,7)
956 printf(", OK.\n");
957 return 0;
958#else
959 printf(", expected version 1.2.7 or higher\n");
960 return 1;
961#endif
962}
963EOF
964 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
965 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
966 if test_execute; then
967 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
968 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
969 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
970 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
971 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
972 fi
973 fi
974 else
975 log_failure "not found"
976 fail
977 fi
978}
979
980#
981# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
982#
983check_sdl_ttf()
984{
985 test_header SDL_ttf
986 cat > .tmp_src.cc << EOF
987#include <cstdio>
988#include <SDL_ttf.h>
989#ifndef SDL_TTF_MAJOR_VERSION
990#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
991#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
992#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
993#endif
994extern "C" int main(void)
995{
996 printf("found version %d.%d.%d",
997 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
998#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
999 printf(", OK.\n");
1000 return 0;
1001#else
1002 printf(", expected version 2.0.6 or higher\n");
1003 return 1;
1004#endif
1005}
1006EOF
1007 if test_compile "-lSDL_ttf1 $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1008 test_execute nofatal
1009 fi
1010}
1011
1012#
1013# Check for libasound, needed by the ALSA audio backend
1014#
1015check_alsa()
1016{
1017 test_header ALSA
1018 cat > .tmp_src.cc << EOF
1019#include <cstdio>
1020#include <alsa/asoundlib.h>
1021extern "C" int main(void)
1022{
1023 printf("found version %d.%d.%d",
1024 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1025#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10006
1026 printf(", OK.\n");
1027 return 0;
1028#else
1029 printf(", expected version 1.0.6 or higher\n");
1030 return 1;
1031#endif
1032}
1033EOF
1034 if test_compile "-lasound" asound asound; then
1035 test_execute
1036 fi
1037}
1038
1039#
1040# Check for PulseAudio
1041#
1042check_pulse()
1043{
1044 test_header "PulseAudio"
1045 cat > .tmp_src.cc << EOF
1046#include <cstdio>
1047#include <pulse/version.h>
1048extern "C" int main(void)
1049{
1050 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1051#if PA_API_VERSION >= 9
1052 printf(", OK.\n");
1053 return 0;
1054#else
1055 printf(", expected version 0.9.0 (API version 9) or higher\n");
1056 return 1;
1057#endif
1058}
1059EOF
1060 if test_compile "-lpulse" pulse pulse; then
1061 test_execute
1062 fi
1063}
1064
1065#
1066# Check for the Xcursor library, needed by VBoxSDL and VBoxBFE
1067#
1068check_xcursor()
1069{
1070 test_header Xcursor
1071 cat > .tmp_src.cc << EOF
1072#include <cstdio>
1073#include <X11/Xlib.h>
1074#include <X11/Xcursor/Xcursor.h>
1075extern "C" int main(void)
1076{
1077 XcursorImage *cursor = XcursorImageCreate (10, 10);
1078 XcursorImageDestroy(cursor);
1079 return 0;
1080}
1081EOF
1082 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1083 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1084 log_success "found"
1085 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1086 fi
1087}
1088
1089#
1090# Check for the X libraries (Xext, X11)
1091#
1092check_x()
1093{
1094 test_header "X libraries"
1095 cat > .tmp_src.cc << EOF
1096#include <cstdio>
1097#include <X11/Xlib.h>
1098extern "C" int main(void)
1099{
1100 Display *dpy;
1101 int scrn_num;
1102 Screen *scrn;
1103 Window win;
1104
1105 dpy = XOpenDisplay(NULL);
1106 scrn_num = DefaultScreen(dpy);
1107 scrn = ScreenOfDisplay(dpy, scrn_num);
1108 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1109 0, 16, InputOutput, CopyFromParent, 0, NULL);
1110 XDestroyWindow(dpy, win);
1111}
1112EOF
1113 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1114 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1115 log_success "found"
1116 fi
1117}
1118
1119#
1120# Check for the Qt3 library, needed by VirtualBox
1121#
1122check_qt3()
1123{
1124 test_header Qt3
1125 cat > .tmp_src.cc << EOF
1126#include <cstdio>
1127#include <qglobal.h>
1128extern "C" int main(void)
1129{
1130 printf("found version %s", QT_VERSION_STR);
1131#if QT_VERSION >= 0x030305
1132 printf(", OK.\n");
1133 return 0;
1134#elif QT_VERSION >= 0x030300
1135 printf("\n ** WARNING: QT < 3.3.5 has known problems!\n");
1136#else
1137 printf(", expected version 3.3.0 or higher\n");
1138 return 1;
1139#endif
1140}
1141EOF
1142 found_qt=0
1143 libs="lib"
1144 [ "$LIB" = "lib64" ] && libs="$libs lib64"
1145 for q in $QT3DIR; do
1146 for l in $libs; do
1147 echo "compiling the following source file:" >> $LOG
1148 cat .tmp_src.cc >> $LOG
1149 echo "using the following command line:" >> $LOG
1150 echo "$CXX -O -Wall -o .tmp_out .tmp_src.cc -I$q/include -L$q/$l -lqt-mt $LIBPTHREAD" >> $LOG
1151 $CXX -O -Wall -o .tmp_out .tmp_src.cc -I$q/include -L$q/$l -lqt-mt $LIBPTHREAD >> $LOG 2>&1
1152 if [ $? -eq 0 ]; then
1153 if test_execute; then
1154 cnf_append "QTDIR" "`cd $q ; pwd`"
1155 found_qt=1
1156 break
1157 fi
1158 fi
1159 done
1160 if [ $found_qt -eq 1 ]; then
1161 break
1162 fi
1163 done
1164 if [ $found_qt -ne 1 ]; then
1165 echo
1166 echo " Qt3 not found at \"$QT3DIR\" or Qt3 headers not found"
1167 echo " Check the file $LOG for detailed error information."
1168 fail
1169 return 1
1170 fi
1171 test_header "Qt3 devtools"
1172 if check_avail "$q/bin/moc" QT3DIR/bin; then
1173 moc_ver=`$q/bin/moc 2>&1 -v|sed 's+^.*(Qt \(.*\))+\1+'`
1174 if [ $? -ne 0 ]; then
1175 log_failure "not found"
1176 fail
1177 else
1178 log_success "found version $moc_ver"
1179 fi
1180 fi
1181}
1182
1183#
1184# Check for the Qt4 library, needed by VirtualBox4
1185#
1186# Currently not fatal.
1187#
1188check_qt4()
1189{
1190 test_header Qt4
1191 if [ "$OS" = "darwin" ]; then
1192 if [ -f "/System/Library/Frameworks/QtCore.framework/QtCore" ]; then
1193 PATH_SDK_QT4="/System/Library/Framework/QtCore.framework"
1194 elif [ -f "/Library/Frameworks/QtCore.framework/QtCore" ]; then
1195 PATH_SDK_QT4="/Library/Frameworks/QtCore.framework"
1196 fi
1197 if [ -n "$PATH_SDK_QT4" ]; then
1198 foundqt4=1
1199 INCQT4="$PATH_SDK_QT4/Headers"
1200 LIBQT4=
1201 FLDQT4="-framework QtCore"
1202 else
1203 log_failure "Qt4 framework not found"
1204 fail
1205 fi
1206 else
1207 if which_wrapper pkg-config > /dev/null; then
1208 qt4_ver=`pkg-config QtCore --modversion 2>> $LOG`
1209 if [ $? -ne 0 ]; then
1210 log_failure "not found"
1211 # fail
1212 else
1213 FLGQT4=`pkg-config QtCore --cflags`
1214 INCQT4=`strip_I "$FLGQT4"`
1215 LIBQT4=`pkg-config QtCore --libs`
1216 foundqt4=1
1217 fi
1218 else
1219 log_failure "pkg-config not found"
1220# not yet
1221# fail
1222 fi
1223 fi
1224 if [ -n "$foundqt4" ]; then
1225 cat > .tmp_src.cc << EOF
1226#include <cstdio>
1227#include <QtGlobal>
1228extern "C" int main(void)
1229{
1230 printf("found version %s", QT_VERSION_STR);
1231#if QT_VERSION >= 0x040200
1232 printf(", OK.\n");
1233 return 0;
1234 printf(", expected version 4.2.0 or higher\n");
1235 return 1;
1236#endif
1237}
1238EOF
1239 [ -n "$INCQT4" ] && I_INCQT4=`prefix_I "$INCQT4"`
1240 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLDQT4" qt4 qt4 nofatal; then
1241 if test_execute; then
1242# cnf_append "SDK_VBOX_LIBQT4_INCS" "$INCQT4"
1243# cnf_append "SDK_VBOX_LIBQT4_LIBS" "`strip_l "$LIBQT4"`"
1244 if [ "$OS" = "darwin" ]; then
1245 cnf_append "VBOX_WITH_QT4GUI" "1"
1246 else
1247 test_header "Qt4 devtools"
1248 for q in $QT4DIR; do
1249 if which_wrapper "$q/bin/moc" > /dev/null; then
1250 moc_ver=`$q/bin/moc -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1251 if [ $? -ne 0 ]; then
1252 log_failure "not found"
1253 fail
1254 else
1255 log_success "found version $moc_ver"
1256 cnf_append "VBOX_PATH_QT4" "$q"
1257 test_header "Qt4 uic3"
1258 for r in $q/bin $QT4UIC3DIR; do
1259 if which_wrapper "$r/uic3" > /dev/null; then
1260 uic3_ver=`$r/uic3 -version 2>&1|sed 's+^.*version \(.*\)+\1+'`
1261 if [ $? -ne 0 ]; then
1262 log_failure "not found"
1263 fail
1264 else
1265 log_success "found version $uic3_ver"
1266 cnf_append "VBOX_UIC3" "$r/uic3"
1267 return
1268 fi
1269 fi
1270 done
1271 log_failure "not found"
1272 fail
1273 fi
1274 fi
1275 done
1276 fi
1277 fi
1278 else
1279 log_failure "not found"
1280 fail
1281 fi
1282 fi
1283}
1284
1285
1286#
1287# Check whether static libstdc++ is installed
1288#
1289check_staticlibstdcxx()
1290{
1291 test_header "static stc++ library"
1292 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1293 cat > .tmp_src.cc << EOF
1294#include <string>
1295
1296extern "C" int main(void)
1297{
1298 std::string s = "test";
1299 return 0;
1300}
1301EOF
1302 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1303 log_success "found"
1304 fi
1305}
1306
1307#
1308# Check for Linux sources
1309#
1310check_linux()
1311{
1312 test_header "Linux kernel sources"
1313 cat > .tmp_src.c << EOF
1314#include <linux/version.h>
1315int printf(const char *format, ...);
1316int main(void)
1317{
1318 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1319 (LINUX_VERSION_CODE % 65536) / 256,
1320 LINUX_VERSION_CODE % 256);
1321#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1322 printf(", OK.\n");
1323 return 0;
1324#else
1325 printf(", expected version 2.4.0 or higher\n");
1326 return 1;
1327#endif
1328}
1329EOF
1330 echo "compiling the following source file:" >> $LOG
1331 cat .tmp_src.c >> $LOG
1332 echo "using the following command line:" >> $LOG
1333 echo "$CC -O -Wall -o .tmp_out .tmp_src.c -nostdinc -I$LINUX/include" >> $LOG
1334 $CC -O -Wall -o .tmp_out .tmp_src.c -nostdinc -I$LINUX/include >> $LOG 2>&1
1335 if [ $? -ne 0 ]; then
1336 echo
1337 echo " Linux kernel headers not found at $LINUX"
1338 echo " Check the file $LOG for detailed error information."
1339 fail
1340 else
1341 if test_execute; then
1342 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1343 fi
1344 fi
1345}
1346
1347#
1348# Check for kchmviewer, needed to display the online help
1349#
1350check_kchmviewer()
1351{
1352 test_header kchmviewer
1353 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1354 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1355 if [ $? -ne 0 ]; then
1356 log_failure "not found"
1357 fail
1358 else
1359 log_success "found version $kchmviewer_ver"
1360 fi
1361 fi
1362}
1363
1364#
1365# Check for the kBuild tools, we don't support GNU make
1366#
1367check_kbuild()
1368{
1369 test_header kBuild
1370 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1371 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1372 echo "export PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1373 echo "export PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1374 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1375 echo "export PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1376 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1377 if [ "$OS" = "solaris" ]; then
1378 # Because of sh being non-default shell in Solaris we need to export PATH again when
1379 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1380 echo "PATH=\"$ORGPATH\"" >> $ENV
1381 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1382 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1383 else
1384 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1385 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1386 fi
1387 echo "export PATH" >> $ENV
1388 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1389 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1390 elif check_avail "kmk" KBUILDDIR really; then
1391 # check for installed kBuild
1392 KBUILD_SED="`which_wrapper kmk_sed`"
1393 else
1394 fail
1395 fi
1396 log_success "found"
1397}
1398
1399
1400#
1401# Check for compiler.h
1402# Some Linux distributions include "compiler.h" in their libc linux
1403# headers package, some don't. Most don't need it, building might (!)
1404# not succeed on openSUSE without it.
1405#
1406# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1407#
1408check_compiler_h()
1409{
1410 test_header compiler.h
1411 if ! test -f "/usr/include/linux/compiler.h"; then
1412 cnf_append "VBOX_WITHOUT_LINUX_COMPILER_H" "1"
1413 log_success "compiler.h not found"
1414 else
1415 log_success "compiler.h found"
1416 fi
1417}
1418
1419
1420#
1421# Check if we are able to build 32-bit applications (needed for the guest additions)
1422#
1423check_32bit()
1424{
1425 test_header "32-bit support"
1426 cat > .tmp_src.c << EOF
1427#include <stdint.h>
1428int main(void)
1429{
1430 return 0;
1431}
1432EOF
1433 echo "compiling the following source file:" >> $LOG
1434 cat .tmp_src.c >> $LOG
1435 echo "using the following command line:" >> $LOG
1436 echo "$CC -m32 -O -Wall -o .tmp_out .tmp_src.c" >> $LOG
1437 $CC -m32 -O -Wall -o .tmp_out .tmp_src.c >> $LOG 2>&1
1438 if [ $? -ne 0 ]; then
1439 echo
1440 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1441 echo " Check the file $LOG for detailed error information."
1442 fail
1443 fi
1444 log_success ""
1445}
1446
1447#
1448# Setup wine
1449#
1450setup_wine()
1451{
1452 test_header "Wine support"
1453 if ! which_wrapper wine > /dev/null; then
1454 echo " wine binary not found"
1455 fail
1456 fi
1457 if ! which_wrapper wineprefixcreate > /dev/null; then
1458 echo " wineprefixcreate not found"
1459 fail
1460 fi
1461 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
1462 echo "export WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
1463 rm -rf $WINEPREFIX
1464 mkdir -p $WINEPREFIX
1465 touch $WINEPREFIX/.no_prelaunch_window_flag
1466 if ! wineprefixcreate -q > /dev/null 2>&1; then
1467 echo " wineprefixcreate failed"
1468 fail
1469 fi
1470 tmp=.tmp.wine.reg
1471 rm -f $tmp
1472 echo 'REGEDIT4' > $tmp
1473 echo '' >> $tmp
1474 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
1475 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
1476 echo '' >> $tmp
1477 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
1478 echo '"itss"="native"' >> $tmp
1479 echo '' >> $tmp
1480 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
1481 echo '"itss"="native"' >> $tmp
1482 echo '' >> $tmp
1483 if ! wine regedit $tmp > /dev/null 2>&1; then
1484 rm -f $tmp
1485 echo " failed to load registry changes (path)."
1486 fail
1487 fi
1488 rm -f $tmp
1489 log_success "found"
1490}
1491
1492
1493#
1494# Determins the darwin version.
1495# @todo This should really check the Xcode/SDK version.
1496#
1497check_darwinversion()
1498{
1499 test_header "Darwin version"
1500 darwin_ver=`uname -r`
1501 case "$darwin_ver" in
1502 9\.*)
1503 darwin_ver="10.5"
1504 cnf_append "VBOX_TARGET_MAC_OS_X_VERSION_10_5" "1"
1505 ;;
1506 8\.*)
1507 darwin_ver="10.5"
1508 ;;
1509 *)
1510 echo " failed to determin darwin version. (uname -r: $darwin_ver)"
1511 fail
1512 darwin_ver="unknown"
1513 ;;
1514 esac
1515 log_success "found version $darwin_ver"
1516}
1517
1518
1519#
1520# Checks that i386-elf-gcc-3.4.6, i386-elf-gcc-3.4.3, i386-elf-gcc-3.4 or i386-elf-gcc
1521# is around to prevent confusion when the build fails in src/recompiler.
1522# Note. Keep the which order in sync with the $(which ) in src/recompiler/Makefile.kmk.
1523#
1524check_i386elfgcc()
1525{
1526 test_header "i386-elf-gcc"
1527 i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.6`
1528 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.3`
1529 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4`
1530 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc`
1531 if test -z "$i386_elf_gcc"; then
1532 echo " failed to find i386-elf-gcc"
1533 fail
1534 fi
1535 log_success "found $i386_elf_gcc"
1536}
1537
1538
1539#
1540# Show help
1541#
1542show_help()
1543{
1544 cat << EOF
1545Usage: ./configure [OPTIONS]...
1546
1547Configuration:
1548 -h, --help display this help and exit
1549 --nofatal don't abort on errors
1550 --disable-xpcom disable XPCOM and related stuff
1551 --disable-sdl-ttf disable SDL_ttf detection
1552 --disable-alsa disable the ALSA sound backend
1553 --disable-pulse disable the PulseAudio backend
1554 --disable-kmods don't build Linux kernel modules (host and guest)
1555 --build-libxml2 build libxml2 from sources
1556 --build-libxslt build libxslt from sources (not OSE!)
1557 --setup-wine setup a Wine directory and register the hhc hack
1558
1559Paths:
1560 --with-gcc=PATH location of the gcc compiler [$CC]
1561 --with-g++=PATH location of the g++ compiler [$CXX]
1562 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
1563 --with-iasl=PATH location of the iasl compiler [$IASL]
1564 --with-linux=DIR Linux kernel source directory [$LINUX]
1565 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
1566 --with-qt-dir=DIR directory for Qt3 headers/libraries [$QT3DIR]
1567 --with-qt4-dir=DIR directory for Qt4 headers/libraries [$QT4DIR]
1568
1569Build type:
1570 -d, --build-debug build with debugging symbols and assertions
1571 --build-profile build with profiling support
1572 --build-headless build headless (without any X11 frontend)
1573EOF
1574 exit 0
1575}
1576
1577
1578#
1579# The body.
1580#
1581
1582# scan command line options
1583for option in $*; do
1584 case "$option" in
1585 --help|-help|-h)
1586 show_help
1587 ;;
1588 --nofatal)
1589 nofatal=1
1590 ;;
1591 --with-gcc=*)
1592 CC=`echo $option | cut -d'=' -f2`
1593 ;;
1594 --with-g++=*)
1595 CXX=`echo $option | cut -d'=' -f2`
1596 ;;
1597 --with-kbuild=*)
1598 KBUILDDIR=`echo $option | cut -d'=' -f2`
1599 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
1600 echo "Error: KBUILDDIR contains invalid characters!"
1601 exit 1
1602 fi
1603 ;;
1604 --with-qt-dir=*)
1605 QT3DIR=`echo $option | cut -d'=' -f2`
1606 ;;
1607 --with-qt4-dir=*)
1608 QT4DIR=`echo $option | cut -d'=' -f2`
1609 ;;
1610 --with-iasl=*)
1611 IASL=`echo $option | cut -d'=' -f2`
1612 ;;
1613 --with-linux=*)
1614 LINUX=`echo $option | cut -d'=' -f2`
1615 ;;
1616 --with-mkisofs=*)
1617 MKISOFS=`echo $option | cut -d'=' -f2`
1618 ;;
1619 --disable-xpcom)
1620 WITH_XPCOM=0
1621 ;;
1622 --disable-sdl-ttf)
1623 WITH_SDL_TTF=0
1624 ;;
1625 --disable-qt)
1626 WITH_QT=0
1627 WITH_QT4=0
1628 ;;
1629 --disable-qt4)
1630 WITH_QT4=0
1631 ;;
1632 --disable-alsa)
1633 WITH_ALSA=0
1634 ;;
1635 --disable-pulse)
1636 WITH_PULSE=0
1637 ;;
1638 --disable-kmods)
1639 WITH_KMODS=0
1640 ;;
1641 --build-debug|-d)
1642 BUILD_TYPE=debug
1643 ;;
1644 --build-profile)
1645 BUILD_TYPE=profile
1646 ;;
1647 --build-libxml2)
1648 BUILD_LIBXML2=1
1649 ;;
1650 --build-libxslt)
1651 BUILD_LIBXSLT=1
1652 ;;
1653 --build-headless)
1654 HEADLESS=1
1655 WITH_SDL=0
1656 WITH_SDL_TTF=0
1657 WITH_X11=0
1658 WITH_QT=0
1659 WITH_QT4=0
1660 ;;
1661 --ose)
1662 OSE=2
1663 ;;
1664 --odir=*)
1665 ODIR="`echo $option | cut -d'=' -f2`/"
1666 ;;
1667 --setup-wine)
1668 SETUP_WINE=1
1669 ;;
1670 *)
1671 echo
1672 echo "Unrecognized option \"$option\""
1673 echo
1674 show_help
1675 ;;
1676 esac
1677done
1678
1679LOG="$ODIR$LOG"
1680ENV="$ODIR$ENV"
1681CNF="$ODIR$CNF"
1682
1683# initialize output files
1684cat > $LOG << EOF
1685# Log file generated by
1686#
1687# '$0 $*'
1688#
1689
1690EOF
1691cat > $CNF << EOF
1692# -*- Makefile -*-
1693#
1694# automatically generated by
1695#
1696# '$0 $*'
1697#
1698# It will be completely overwritten if configure is executed again.
1699#
1700
1701EOF
1702cat > $ENV << EOF
1703#!/bin/bash
1704#
1705# automatically generated by
1706#
1707# '$0 $*'
1708#
1709# It will be completely overwritten if configure is executed again.
1710# Make sure you source this file once before you start to build VBox.
1711#
1712
1713EOF
1714
1715# test if we are OSE
1716if [ $OSE -eq 1 -a -d "`cd \`dirname $0\`; pwd`/src/VBox/Devices/USB" ]; then
1717 echo "Found USB devices, assuming VBOX_OSE = FALSE" >> $LOG
1718 echo >> $LOG
1719 OSE=0
1720fi
1721
1722if [ "$BUILD_TYPE" = "debug" ]; then
1723 echo "Creating DEBUG build!" >> $LOG
1724elif [ "$BUILD_TYPE" = "profile" ]; then
1725 echo "Creating PROFILE build!" >> $LOG
1726fi
1727
1728# first determine our environment
1729check_environment
1730check_kbuild
1731
1732# append the tools directory to the default search path
1733echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
1734export PATH
1735
1736# some things are not available in for OSE
1737if [ $OSE -ge 1 ]; then
1738 cnf_append "VBOX_OSE" "1"
1739 cnf_append "VBOX_WITH_TESTSUITE" ""
1740 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
1741
1742 if [ "$OS" = "linux" ]; then
1743 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
1744 else
1745 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
1746 fi
1747 echo >> $CNF
1748fi
1749
1750# headless
1751if [ -n "$HEADLESS" ]; then
1752 cnf_append "VBOX_HEADLESS" "1"
1753fi
1754
1755if [ "$OS" = "darwin" ]; then
1756 # On Darwin we want to build against Qt4 only. WITH_QT4 is enabled by
1757 # default so disable Qt3. --disable-qt disables both Qt3 and Qt4 GUI now,
1758 # --disable-qt4 disables only the Qt4 GUI (which is not appropriate for
1759 # Darwin as we disable the Qt3 here anyway.
1760 WITH_QT=0
1761 BUILD_LIBXSLT=1
1762 BUILD_LIBXML2=1
1763fi
1764
1765# emit disable directives corresponding to any --disable-xxx options.
1766[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
1767[ $WITH_QT -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
1768[ $WITH_QT4 -eq 0 ] && cnf_append "VBOX_WITH_QT4GUI" ""
1769[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
1770
1771# the tools
1772check_gcc
1773[ "$OS" != "darwin" ] && check_as86
1774[ "$OS" != "darwin" ] && check_bcc
1775[ "$OS" != "darwin" ] && check_iasl
1776# don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
1777# [ "$OS" != "darwin" ] && check_yasm
1778[ "$OS" != "darwin" ] && check_xsltproc
1779[ $OSE -eq 0 -a "$OS" != "darwin" ] && check_mkisofs
1780
1781# the libraries
1782[ "$OS" != "darwin" ] && check_pthread
1783[ $WITH_XPCOM -eq 1 ] && check_libxml2
1784[ $WITH_XPCOM -eq 1 ] && check_libxslt
1785[ $WITH_LIBIDL -eq 1 ] && check_libidl
1786# build openssl on Darwin in every case
1787[ "$OS" != "darwin" -a $OSE -eq 0 ] && check_ssl
1788[ "$OS" != "darwin" ] && check_z
1789[ "$OS" != "darwin" ] && check_png
1790[ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
1791[ $WITH_SDL -eq 1 ] && check_sdl
1792[ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
1793[ $WITH_X11 -eq 1 ] && check_x
1794[ $WITH_X11 -eq 1 ] && check_xcursor
1795[ $WITH_QT -eq 1 ] && check_qt3
1796[ $WITH_QT4 -eq 1 ] && check_qt4
1797
1798# Linux-specific
1799if [ "$OS" = "linux" ]; then
1800 check_staticlibstdcxx
1801 if [ $WITH_KMODS -eq 1 ]; then
1802 check_linux
1803 else
1804 cnf_append "VBOX_LINUX_SRC" ""
1805 cnf_append "VBOX_WITH_VBOXDRV" ""
1806 cnf_append "VBOX_WITH_LINUX_ADDITIONS_32BIT_R0" ""
1807 fi
1808 if [ $WITH_ALSA -eq 1 ]; then
1809 check_alsa
1810 else
1811 cnf_append "VBOX_WITH_ALSA" ""
1812 fi
1813 if [ $WITH_PULSE -eq 1 ]; then
1814 check_pulse
1815 else
1816 cnf_append "VBOX_WITH_PULSE" ""
1817 fi
1818 check_compiler_h
1819 [ "$BUILD_MACHINE" = "amd64" ] && check_32bit
1820fi
1821
1822[ -n "$SETUP_WINE" ] && setup_wine
1823
1824# Darwin-specific
1825if [ "$OS" = "darwin" ]; then
1826 check_darwinversion
1827 check_i386elfgcc
1828fi
1829
1830# success!
1831echo
1832echo "Successfully generated '$CNF' and '$ENV'."
1833echo "Source '$ENV' once before you start to build VBox:"
1834echo ""
1835echo " source $ENV"
1836echo " kmk"
1837echo ""
1838if [ "$OS" = "linux" ]; then
1839 echo "To compile the kernel module, do:"
1840 echo ""
1841 echo " cd ./out/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src"
1842 echo " make"
1843 echo ""
1844fi
1845echo "Enjoy!"
1846cleanup
Note: See TracBrowser for help on using the repository browser.

© 2023 Oracle
ContactPrivacy policyTerms of Use